<?php

declare(strict_types=1);

namespace App\Controller\Payment;

use App\Service\PaymentService;
use Hyperf\HttpServer\Contract\RequestInterface;

class NotifyController extends AbstractController
{
    private PaymentService $paymentService;

    public function __construct(PaymentService $paymentService)
    {
        $this->paymentService = $paymentService;
    }

    public function index(RequestInterface $request)
    {
        $params = $request->all();
        return $this->paymentService->notify($params);
    }

    public function efps(RequestInterface $request) {
        $params = $request->all();
        return $this->paymentService->efpsNotify($params);
    }
}
